/****************************************************************************
 * (C) Nicolas GEORGE 1999                                                  *
 * Ce programme fait partie du projet xbackground.                          *
 * Il est distribu sous les termes de la GNU-GPL, dont un exemplaire doit  *
 * tre joint (si ce n'est pas le cas, vous le trouverez sur www.fsf.org).  *
 * Je ne fournis aucune garantie sur ce programme.                          *
 ****************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xbackground.h"

#define INTL 80
#define INTH 60

static int lire_chaine(char *c,char *v)
{
#if 0
  if(!strcmp(c,"size")){
    dl=atoi(v);
    if(dl<3) dl=3;
    if(dl>12) dl=12;
    return(1);
  }
#endif
  return(0);
}

static int initialiser(int *l,int *h)
{
  int i,r,v,b;

  for(i=0;i<nb_col;i++){
    r=0;
    r=r<0?0:r>65535?65535:r;
    v=0;
    v=v<0?0:v>65535?65535:v;
    b=65535*i/(nb_col-1);
    b=b<0?0:b>65535?65535:b;
    pal[i]=((long)(r/257))|(((long)(v/257))<<8)|(((long)(b/257))<<16);
  }
  return(0);
}

static int nombre_iterations(double c1,double c2)
{
  double z1=0.0,z2=0.0,t;
  int i;

  for(i=0;i<255;i++){
    t=z1*z1-z2*z2+c1;
    z2=2*z1*z2+c2;
    z1=t;
    if(z1*z1+z2*z2>4.0) break;
  }
  return(i);
}

static inline int amplitude(int a,int b,int c,int d)
{
  int t;

  t=a;
  if(b<t) t=b;
  if(c<t) t=c;
  if(d<t) t=d;
  if(b>a) a=b;
  if(c>a) a=c;
  if(d>a) a=d;
  return(a-t);
}

static void creer_mandelbrot(int ls,int hs,XImage *img)
{
  int x,y,i;
  int nit;
  unsigned char *ite,*amp,*tmp,*tam;
  double xmin,xmul,ymin;

  xmin=-2.75;
  xmul=4.0/(double)INTL;
  ymin=-1.5;
  ite=malloc(INTL*INTH);
  amp=malloc((INTL-1)*(INTH-1));
  for(i=0;i<2;i++){
    tmp=ite;
    nit=0;
    for(y=0;y<INTH;y++)
      for(x=0;x<INTL;x++)
	*(tmp++)=nombre_iterations(xmin+xmul*x,ymin+xmul*y);
    tmp=ite;
    tam=amp;
    for(y=0;y<INTH-1;y++,tmp++)
      for(x=0;x<INTL-1;x++,tmp++){
	*tam=amplitude(tmp[0],tmp[1],tmp[INTL],tmp[INTL+1]);
	nit+=(int)(*tam)*(int)(*tam);
	tam++;
      }
    if(nit==0) nit=1;
    nit=rand()%nit;
    tam=amp;
    for(x=0;x<(INTL-1)*(INTH-1);x++,tam++){
      nit-=(int)(*tam)*(int)(*tam);
      if(nit<0) break;
    }
    y=x/(INTL-1);
    x%=(INTL-1);
    xmin+=xmul*x;
    ymin+=xmul*y;
    xmul/=(double)INTL/2;
  }
  free(amp);
  free(ite);
  xmul*=(double)INTL/(double)ls;
  for(y=0;y<hs;y++){
    for(x=0;x<ls;x++){
      i=nombre_iterations(xmin+xmul*x,ymin+xmul*y);
      XPutPixel(img,x,y,pal[i*(nb_col-1)/255]);
    }
  }
}

moteur_de_fond moteur_mandelbrot={
  "mandelbrot",
  lire_chaine,
  initialiser,
  creer_mandelbrot
};
