/****************************************************************************
 * (C) Nicolas GEORGE 1999                                                  *
 * Ce programme fait partie du projet xbackground.                          *
 * Il est distribu sous les termes de la GNU-GPL, dont un exemplaire doit  *
 * tre joint (si ce n'est pas le cas, vous le trouverez sur www.fsf.org).  *
 * Je ne fournis aucune garantie sur ce programme.                          *
 ****************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xbackground.h"

int theme=-1,atheme=-1;

int lire_chaine(char *c,char *v)
{
   if(!strcmp(c,"num_themes")){
    int nt;

    nt=atoi(v);
    if(nt<1) nt=1;
    theme=rand()%nt;
    return(1);
  }else if(!strcmp(c,"theme")){
    atheme=atoi(v);
    return(1);
  }else if((atheme>=0)&&(atheme!=theme)){
    return(1);
  }else if(!strcmp(c,"colors")){
    nb_col=atoi(v);
    nb_col=nb_col<4?4:nb_col>255?255:nb_col;
    return(1);
  }else if(!strcmp(c,"type")){
    moteur_de_fond **m;

    for(m=moteurs;*m!=NULL;m++)
      if(!strcmp(v,(*m)->nom))
	break;
    if(*m==NULL){
      fprintf(stderr,"Unknown type\n");
      return(-1);
    }
    moteur=*m;
    return(1);
  }
  return(0);
}

void lire_parametres(void)
{
  char b[1024];
  char *c,*v,*fc;
  int i;

  while(1){
    fgets(b,1024,stdin);
    if(feof(stdin))
      break;
    for(i=0;(i<1023)&&(b[i]!='\n');i++);
    b[i]=0;
    for(c=b;*c==' ';c++);
    if((*c==0)||(*c=='#'))
      continue;
    if(((*c<'a')||(*c>'z'))&&((*c<'A')||(*c>'Z'))){
      fprintf(stderr,"Syntax error\n");
      continue;
    }
    for(v=c;(((*v>='a')&&(*v<='z'))||((*v>='A')&&(*v<='Z'))||
	     ((*v>='0')&&(*v<='9'))||(*v=='_'));v++);
    fc=v;
    for(;*v==' ';v++);
    if(*v!='='){
      fprintf(stderr,"Syntax error\n");
      continue;
    }
    *fc=0;
    for(v++;*v==' ';v++);
    if(!lire_chaine(c,v))
      if(!moteur->lire_chaine(c,v))
	fprintf(stderr,"Unknown key: %s\n",c);
  }
}
